class RecursiveExploder
  def explode()
    model = Sketchup.active_model
    selection = model.selection
    model.start_operation("Explode Recursively", true)
    recursiveExplode(selection)
    model.commit_operation
  end

  def recursiveExplode(entities)
    if entities.nil?
      # empy on purpose
      else
      entities.each do |entity|
        if entity.is_a? Sketchup::Group
        explodedEntities = entity.explode
        recursiveExplode(explodedEntities)
        end
        if entity.is_a? Sketchup::ComponentInstance
        explodedEntities = entity.explode
        recursiveExplode(explodedEntities)
        end
      end
    end
  end
end

add_separator_to_menu("Tools")
toolsmenu = UI.menu("Tools")
cmd = UI::Command.new("Explode Recursively") {
  aRecursiveExploder = RecursiveExploder.new
  aRecursiveExploder.explode
}
cmd.menu_text = "Explode Recursively"
toolsmenu.add_item cmd
puts cmd.menu_text